﻿$(document).ready(function () {
    $("#objectTree").testPassObjectNvps();
});
(function ($) {       
    var methods = {
        init: function (args) {
            $(this).testPassObjectNvps("loadPage", args);
        },

        loadPage: function (args) {
            var container = $(this); 
            var nvpsGetLink = container.find("#nvpsToNestGet");            
            if (nvpsGetLink != null) {
                nvpsGetLink.click(function (event) {
                    methods.nvpsToNestGet(container);
                });
            }
            $("#nvpsToNestPost").click(function (event) {
                methods.nvpsToNestPost(container);
            });
            $("#nvpsToNestCollectionGet").click(function (event) {
                methods.nvpsToNestCollectionGet(container);
            });            
            $("#stringListOrArrayGet").click(function (event) {
                methods.stringListOrArrayGet(container);
            });

            //Load default test parameters.
            $(".loadDefaultTestPrmsForSimpleNest").click(function (event) {
                $("#txaInput").val("CategoryId=3&PageIndex=0&PageSize=8&SortBy=ProductName&SortDirection=descending");
            });
            $("#loadDefaultTestPrmsForCollection").click(function (event) {
                $("#txaInput").val("CategoryId=3&PagingRequest[0]PageIndex=1&PagingRequest[0]PageSize=8&PagingRequest[0]Sort[0]SortBy=ProductName&PagingRequest[0]Sort[0]SortDirection=descending&PagingRequest[0]Sort[1]SortBy=CategoryID&PagingRequest[0]Sort[1]SortDirection=0&PagingRequest[1]PageIndex=2&PagingRequest[1]PageSize=5&PagingRequest[1]Sort[0]SortBy=CategoryID&PagingRequest[1]Sort[0]SortDirection=0&PagingRequest[1]Sort[1]SortBy=ProductName&PagingRequest[1]Sort[1]SortDirection=Descending&Test=OK");
            });
            $("#loadDefaultTestPrmsForStrings").click(function (event) {
                $("#txaInput").val("PageIndex=1&PageSize=8&RootStrings[0]=OK&RootStrings[1]=Yes&RootStrings[2]=456&Sort2[0]SortBy=ProductName&Sort2[0]SortDirection=descending&Sort2[0]InStrings[0]=Search&Sort2[0]InStrings[1]=Find&Sort2[1]SortBy=CategoryID&Sort2[1]SortDirection=0&Sort2[1]InStrings[0]=Here&Sort2[1]InStrings[1]=Also");
            });
        }, // End loadPage function
        
        nvpsToNestGet: function (container) {
            var input = container.find("#txaInput").val();
            //var input = 'CategoryId=3&PageIndex=0&PageSize=8&SortBy=ProductName&SortDirection=descending'
            //var input = 'CategoryId=3&PageIndex=0&PageSize=8&SortBy=ProductName&PageIndex=2';
            //var input = 'CategoryId=3&PageIndex=0&PageSize=8&PagingRequest_M[0]Sort[0]SortBy=ProductName&PagingRequest_M[0]Sort[0]PageIndex=2';
            var uri = 'api/nvpstonestget?' + input;
            $.ajax({
                url: uri,
                type: "GET",
                dataType: "json",                
                success: function (data) {                    
                    var list = displayListObjects(data);                    
                    $("#objectDiv").empty();
                    $("#inputTitle").text("Pass for Nesting Object to Get");
                    list.appendTo($("#objectDiv"));
                    $("#displayDiv").show();
                },
                error: function (XMLHttpRequest, textStatus, errorThrown) {
                    alert(errorThrown);
                }
            });
        },      

        nvpsToNestPost: function (container) {
            var input = container.find("#txaInput").val();
            //var input = 'CategoryId=3&PagingRequest[0]PageIndex=1&PagingRequest[0]PageSize=8&PagingRequest[0]Sort[0]SortBy=CategoryID&PagingRequest[0]Sort[0]SortDirection=1&PagingRequest[0]Sort[1]SortBy=CategoryID&PagingRequest[0]Sort[1]SortDirection=0&PagingRequest[1]PageIndex=2&PagingRequest[1]PageSize=5&PagingRequest[1]Sort[0]SortBy=CategoryID&PagingRequest[1]Sort[0]SortDirection=0&PagingRequest[1]Sort[1]SortBy=ProductName&PagingRequest[1]Sort[1]SortDirection=1&Test=OK';
            var uri = 'api/nvpstonestpost';
            $.ajax({
                url: uri,
                type: "POST",
                data: input, 
                dataType: "json",
                contentType: "application/x-www-form-urlencoded; charset=utf-8",
                success: function (data) {
                    var list = displayListObjects(data);
                    $("#inputTitle").text("Pass for Nesting Object to Post");
                    $("#objectDiv").empty();
                    list.appendTo($("#objectDiv"));
                    $("#displayDiv").show();
                },
                error: function (XMLHttpRequest, textStatus, errorThrown) {
                    alert(errorThrown);
                }
            });
        },

        nvpsToNestCollectionGet: function (container) {
            var input = container.find("#txaInput").val();
            //var input = 'CategoryId=3&PagingRequest[0]PageIndex=1&PagingRequest[0]PageSize=8&PagingRequest[0]Sort[0]SortBy=ProductName&PagingRequest[0]Sort[0]SortDirection=descending&PagingRequest[0]Sort[1]SortBy=CategoryID&PagingRequest[0]Sort[1]SortDirection=0&PagingRequest[1]PageIndex=2&PagingRequest[1]PageSize=5&PagingRequest[1]Sort[0]SortBy=CategoryID&PagingRequest[1]Sort[0]SortDirection=0&PagingRequest[1]Sort[1]SortBy=ProductName&PagingRequest[1]Sort[1]SortDirection=Descending&Test=OK';
            var uri = 'api/nvpstonestcollectionget?' + input;
            $.ajax({
                url: uri,
                type: "GET",
                dataType: "json",
                //contentType: "application/x-www-form-urlencoded; charset=utf-8",
                success: function (data) {
                    var list = displayListObjects(data);
                    $("#objectDiv").empty();
                    $("#inputTitle").text("Pass for Nesting Collection Object to Get");
                    list.appendTo($("#objectDiv"));
                    $("#displayDiv").show();
                },
                error: function (XMLHttpRequest, textStatus, errorThrown) {
                    alert(errorThrown);
                }
            });
        },

        stringListOrArrayGet: function (container) {
            var input = container.find("#txaInput").val(); 
            //Test for List<string>. May need delete browser cache after each change in uri.            
            //var input = 'PageIndex=1&PageSize=8&RootStrings[0]=OK&RootStrings[1]=Yes&RootStrings[2]=456&Sort2[0]SortBy=ProductName&Sort2[0]SortDirection=descending&Sort2[0]InStrings[0]=Search&Sort2[0]InStrings[1]=Find&Sort2[1]SortBy=CategoryID&Sort2[1]SortDirection=0&Sort2[1]InStrings[0]=Here&Sort2[1]InStrings[1]=Also';
            var uri = 'api/stringlistorarrayget?' + input;
            $.ajax({
                url: uri,
                type: "GET",
                dataType: "json",                
                success: function (data) {
                    //Test
                    var jsonStr = JSON.stringify(data);
                    var list = displayListObjects(data);
                    $("#objectDiv").empty();
                    $("#inputTitle").text("Pass for String List or Array Object to Get");
                    list.appendTo($("#objectDiv"));
                    $("#displayDiv").show();
                },
                error: function (XMLHttpRequest, textStatus, errorThrown) {
                    alert(errorThrown);
                }
            });
        }
    };
        
    $.fn.testPassObjectNvps = function (method) {
        if (methods[method]) {
            return methods[method].apply(this, Array.prototype.slice.call(arguments, 1));
        } else if (typeof method === 'object' || !method) {
            return methods.init.apply(this, arguments);
        } else {
            $.error('Method ' + method + ' does not exist in TestProducts.js plug-in');
        }
    };
})(jQuery);

