﻿'use strict'

//Declare app level module which depends on filters, and services
angular.module('smApp', ['smApp.controllers', 'smApp.AppServices', 'ui.bootstrap', 'ngSanitize', function () {
}])
;

//Controller module.
angular.module('smApp.controllers', ['ui.bootstrap', function () {
}])

.controller('sampleController', ['$scope', '$http', 'postNvpsToNest', 'postStringListOrArray', 'utilService', function ($scope, $http, postNvpsToNest, postStringListOrArray, utilService) {
    $scope.displayDiv = false;
    $scope.objectDiv = '';

    $scope.txaInput = 'CategoryId=3&PageIndex=0&PageSize=8&SortBy=ProductName&SortDirection=descending';

    $scope.loadDefaultTestPrmsForSimpleNest = function () {
        $scope.txaInput = 'CategoryId=3&PageIndex=0&PageSize=8&SortBy=ProductName&SortDirection=descending';
    }
    $scope.loadDefaultTestPrmsForCollection = function () {
        $scope.txaInput = 'CategoryId=3&PagingRequest[0]PageIndex=1&PagingRequest[0]PageSize=8&PagingRequest[0]Sort[0]SortBy=ProductName&PagingRequest[0]Sort[0]SortDirection=descending&PagingRequest[0]Sort[1]SortBy=CategoryID&PagingRequest[0]Sort[1]SortDirection=0&PagingRequest[1]PageIndex=2&PagingRequest[1]PageSize=5&PagingRequest[1]Sort[0]SortBy=CategoryID&PagingRequest[1]Sort[0]SortDirection=0&PagingRequest[1]Sort[1]SortBy=ProductName&PagingRequest[1]Sort[1]SortDirection=Descending&Test=OK';
    }
    $scope.loadDefaultTestPrmsForStrings = function () {
        $scope.txaInput = 'PageIndex=1&PageSize=8&RootStrings[0]=OK&RootStrings[1]=Yes&RootStrings[2]=456&Sort2[0]SortBy=ProductName&Sort2[0]SortDirection=descending&Sort2[0]InStrings[0]=Search&Sort2[0]InStrings[1]=Find&Sort2[1]SortBy=CategoryID&Sort2[1]SortDirection=0&Sort2[1]InStrings[0]=Here&Sort2[1]InStrings[1]=Also';
    }

    $scope.nvpsToNestGet = function () {
        $http({
            url: 'api/nvpstonestget?' + $scope.txaInput,
            method: "GET"
        }).
        success(function (data, status, headers, config) {
            displayListObjects(data);
            $scope.inputTitle = "Pass for Nesting Object with Get";            
        }).
        error(function (data, status, headers, config) {
            alert("Error getting data: " + status);
        });
    }

    //Post key-value pair string data. 
    $scope.nvpsToNestPost = function () {
        //$http({
        //    url: 'api/nvpstonestpost',
        //    method: "POST",
        //    headers: { 'Content-Type': 'application/x-www-form-urlencoded' },
        //    data: $scope.txaInput
        //}).
        //success(function (data, status, headers, config) {
        //    displayListObjects(data);
        //    $scope.inputTitle = "Pass for Nesting Object with Post";
        //}).
        //error(function (data, status, headers, config) {
        //    alert("Error getting data: " + status);
        //});

        //Using $resource service for POST also works.
        var jsonPrms = $scope.txaInput;
        $scope.rtn = postNvpsToNest.post(jsonPrms, function (data) {
            displayListObjects(data);
            $scope.inputTitle = "Pass for Nesting Object with Post";
        }, function (error) {
            alert("Error getting data.");
        });
    }

    $scope.nvpsToNestCollectionGet = function () {
        $http({
            url: 'api/nvpstonestcollectionget?' + $scope.txaInput,
            method: "GET"
        }).
       success(function (data, status, headers, config) {
           displayListObjects(data);
           $scope.inputTitle = "Pass for Nesting Collection Object with Get";
       }).
       error(function (data, status, headers, config) {
           alert("Error getting data: " + status);
       });
    }

    $scope.stringListOrArrayGet = function () {
        $http({
            url: 'api/stringlistorarrayget?' + $scope.txaInput,
            method: "GET"
        }).
       success(function (data, status, headers, config) {
           displayListObjects(data);
           $scope.inputTitle = "Pass for String List or Array Object with Get";
       }).
       error(function (data, status, headers, config) {
           alert("Error getting data: " + status);
       });
    }

    $scope.stringListOrArrayPost = function () {
        var jsonPrms = $scope.txaInput;
        //Test with Json: OK
        //var jsonPrms = {"PageIndex":1,"PageSize":8,"RootStrings":["OK","Yes","456"],"Sort2":[{"SortBy":"ProductName","SortDirection":1,"InStrings":["Search","Find"]},{"SortBy":"CategoryID","SortDirection":0,"InStrings":["Here","Also"]}]};
        $scope.rtn = postStringListOrArray.post(jsonPrms, function (data) {
            displayListObjects(data);
            $scope.inputTitle = "Pass for String List or Array Object with Get";
        }, function (error) {
            alert("Error getting data.");
        });
    }

    var displayListObjects = function (data) {
        var list = utilService.getListObjects(data);       
        $scope.objectDiv = list[0].outerHTML;
        $scope.displayDiv = true;
    }
}])

.service('utilService', function () {
    this.getListObjects = function (object) {
        return constructListObjects(object)
    }

    var constructListObjects = function (object, parentUl, parentLi) {
        var thisUl = angular.element('<ul>');
        angular.forEach(object, function (val, prop) {
            //Also exclude $promise or $resolved if using $resource service for POST
            if (object.hasOwnProperty(prop) && !(prop == "$promise" || prop == "$resolved")) {                
               if (typeof object[prop] == "object")  {
                    var thisLi = angular.element('<li>').text(prop + ': ');
                    constructListObjects(object[prop], thisUl, thisLi);
                }
                else {
                    thisUl.append(angular.element('<li>').text(prop + ': ' + val));
                }
            }
        });
        if (parentLi != null && parentLi != "undefined") {
            parentLi.append(thisUl);
        }
        if (parentUl != null && parentUl != "undefined") {
            parentUl.append(parentLi);
        }
        else {
            return thisUl;
        }
    }
})
;
